fmBuffCheck = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "FuBarPlugin-2.0", "AceEvent-2.0", "AceConsole-2.0", "AceComm-2.0")

local fmBuffCheck, self = fmBuffCheck, fmBuffCheck
local L = AceLibrary("AceLocale-2.2"):new("fmBuffCheck")
local B = AceLibrary("Babble-Spell-2.2")


fmBuffCheck.commPrefix = "fmbc"
fmBuffCheck.commDist = "GROUP"
fmBuffCheck.player = UnitName("player")

-- Spells

fmBuffCheck.basebuffs =
{
	-- self
	["Battle Elixir"] =               { user = "Self",    sources = { ["Battle Elixir"] = true, ["Flask"] = true } },
	["Guardian Elixir"] =             { user = "Self",    sources = { ["Guardian Elixir"] = true, ["Flask"] = true } },
	["Food Buff"] =                   { user = "Self",    sources = { ["Well Fed"] = true } },
	["Weapon Buff"] =                 { user = "Self",    sources = { ["Weapon"] = true } },
	-- mage
	["Arcane Brilliance/Intellect"] = { user = "Mage",    sources = { ["Arcane Brilliance"] = true, ["Arcane Intellect"] = true } },
	-- warrior
	["Battle Shout"] =                { user = "Warrior", sources = { ["Battle Shout"] = true } },
	["Commanding Shout"] =            { user = "Warrior", sources = { ["Commanding Shout"] = true } },
	-- druid
	["Mark/Gift of the Wild"] =       { user = "Druid",   sources = { ["Mark of the Wild"] = true , ["Gift of the Wild"] = true } },
	["Thorns"] =                      { user = "Druid",   sources = { ["Thorns"] = true } },
	-- priest
	["Fortitude"] =	                  { user = "Priest",  sources = { ["Power Word: Fortitude"] = true , ["Improved Power Word: Fortitude"] = true , ["Prayer of Fortitude"] = true } },
	["Shadow Protection"] =           { user = "Priest",  sources = { ["Shadow Protection"] = true , ["Prayer of Shadow Protection"] = true } },
	["Divine Spirit"] =               { user = "Priest",  sources = { ["Divine Spirit"] = true , ["Prayer of Spirit"] = true } },
	-- warlock
	["Blood Pact"] =                  { user = "Warlock", sources = { ["Blood Pact"] = true } },
	["Detect Invisibility"] =         { user = "Warlock", sources = { ["Detect Invisibility"] = true } },
	-- paladin
	["Blessing of Kings"] =           { user = "Paladin", sources = { ["Blessing of Kings"] = true , ["Greater Blessing of Kings"] = true } },
	["Blessing of Light"] =           { user = "Paladin", sources = { ["Blessing of Light"] = true , ["Greater Blessing of Light"] = true } },
	["Blessing of Might"] =           { user = "Paladin", sources = { ["Blessing of Might"] = true , ["Greater Blessing of Might"] = true } },
	["Blessing of Salvation"] =       { user = "Paladin", sources = { ["Blessing of Salvation"] = true , ["Greater Blessing of Salvation"] = true } },
	["Blessing of Sanctuary"] =       { user = "Paladin", sources = { ["Blessing of Sanctuary"] = true , ["Greater Blessing of Sanctuary"] = true } },
	["Blessing of Wisdom"] =          { user = "Paladin", sources = { ["Blessing of Wisdom"] = true , ["Greater Blessing of Wisdom"] = true } },
	-- rogue <none>
	-- hunter <none>
	-- shaman <none>
}

-- Frame

function fmBuffCheck:LogFrameDone()
	fmBuffCheck.LogFrame:Hide()
end

function fmBuffCheck:LogFrameUpdate()
	fmBuffCheck.LogFrame.Scroll:UpdateScrollChildRect()
	fmBuffCheck.LogFrame.Box:ClearFocus()
end

function fmBuffCheck:LogFrameClear()
	fmBuffCheck.LogFrame.Box:SetText("")
end

function fmBuffCheck:LogFrameShow()
	fmBuffCheck.LogFrame:Show()
end

function fmBuffCheck:LogFrameAdd(txt)
	fmBuffCheck.LogFrame.Box:SetText(self.LogFrame.Box:GetText() .. "\n" .. txt)
end

fmBuffCheck.LogFrame = CreateFrame("Frame", "", UIParent)
fmBuffCheck.LogFrame:Hide()
fmBuffCheck.LogFrame:SetPoint("CENTER", "UIParent", "CENTER")
fmBuffCheck.LogFrame:SetFrameStrata("TOOLTIP")
fmBuffCheck.LogFrame:SetHeight(280)
fmBuffCheck.LogFrame:SetWidth(500)
fmBuffCheck.LogFrame:SetBackdrop({
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = true, tileSize = 32, edgeSize = 32,
	insets = { left = 9, right = 9, top = 9, bottom = 9 }
})
fmBuffCheck.LogFrame:SetBackdropColor(0,0,0, 0.8)

fmBuffCheck.LogFrame.Done = CreateFrame("Button", "", fmBuffCheck.LogFrame, "OptionsButtonTemplate")
fmBuffCheck.LogFrame.Done:SetText("Close")
fmBuffCheck.LogFrame.Done:SetPoint("BOTTOMRIGHT", fmBuffCheck.LogFrame, "BOTTOMRIGHT", -10, 10)
fmBuffCheck.LogFrame.Done:SetScript("OnClick", self.LogFrameDone)

fmBuffCheck.LogFrame.Mesg = fmBuffCheck.LogFrame:CreateFontString("", "OVERLAY", "GameFontNormalSmall")
fmBuffCheck.LogFrame.Mesg:SetJustifyH("LEFT")
fmBuffCheck.LogFrame.Mesg:SetPoint("TOPRIGHT", fmBuffCheck.LogFrame.Done, "TOPLEFT", -10, 0)
fmBuffCheck.LogFrame.Mesg:SetPoint("LEFT", fmBuffCheck.LogFrame, "LEFT", 15, 0)
fmBuffCheck.LogFrame.Mesg:SetHeight(20)
fmBuffCheck.LogFrame.Mesg:SetText(L["You can select all and copy above for further study..."])

fmBuffCheck.LogFrame.Scroll = CreateFrame("ScrollFrame", "fmBuffCheckLogInputScroll", fmBuffCheck.LogFrame, "UIPanelScrollFrameTemplate")
fmBuffCheck.LogFrame.Scroll:SetPoint("TOPLEFT", fmBuffCheck.LogFrame, "TOPLEFT", 20, -20)
fmBuffCheck.LogFrame.Scroll:SetPoint("RIGHT", fmBuffCheck.LogFrame, "RIGHT", -30, 0)
fmBuffCheck.LogFrame.Scroll:SetPoint("BOTTOM", fmBuffCheck.LogFrame.Done, "TOP", 0, 10)

fmBuffCheck.LogFrame.Box = CreateFrame("EditBox", "fmBuffCheckLogEditBox", fmBuffCheck.LogFrame.Scroll)
fmBuffCheck.LogFrame.Box:SetWidth(450)
fmBuffCheck.LogFrame.Box:SetHeight(85)
fmBuffCheck.LogFrame.Box:SetMultiLine(true)
fmBuffCheck.LogFrame.Box:SetAutoFocus(false)
fmBuffCheck.LogFrame.Box:SetFontObject(GameTooltipTextSmall)
fmBuffCheck.LogFrame.Box:SetScript("OnEscapePressed", fmBuffCheck.LogFrameDone)
fmBuffCheck.LogFrame.Box:SetScript("OnTextChanged", fmBuffCheck.LogFrameUpdate)
fmBuffCheck.LogFrame.Scroll:SetScrollChild(fmBuffCheck.LogFrame.Box)

-- FuBar configuration
fmBuffCheck.hasIcon = true
fmBuffCheck.hideWithoutStandby = true
fmBuffCheck.defaultPosition = "MINIMAP"
fmBuffCheck.defaultMinimapPosition = 200
fmBuffCheck.hasNoText = true
fmBuffCheck.hasNoColor = true
fmBuffCheck.cannotDetachTooltip = true
fmBuffCheck.independentProfile = false
fmBuffCheck.blizzardTooltip = true

fmBuffCheck:RegisterDB("fmBuffCheckDB", "fmBuffCheckDBPC")
fmBuffCheck:RegisterDefaults("profile", { 
	debugging = false,
	activeprofile = 1,
	buffprofilecount = 1,
	requesttimeout = 10,
	nagging = true,
	buffprofile = {
		{
			["name"] = "Default",
			["Weapon Buff"] = true,
			["Food Buff"] = true,
			["Guardian Elixir"] = true,
			["Battle Elixir"] = true,
		}
	},
} )

fmBuffCheck.version = tonumber(("$Rev: 46000 $"):match("(%d+)"))
fmBuffCheck.date = ("$Date: 2007-08-08 09:26:36 -0400 (Wed, 08 Aug 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")

fmBuffCheck.options = {
	type = 'group',
	handler = fmBuffCheck,
	args = {
		debugMode = {
			order = 10,
			name = L["Debugging Mode"],
			desc = L["If enabled, additional messages are printed out to help debugging."],
			type = 'toggle',
			get = function() return self.db.profile.debugging end,
			set = function(v) self.db.profile.debugging = v end,
		},
		nagMode = {
			order = 20,
			name = L["Nagging Mode"],
			desc = L["If enabled, every person NOT having all buffs is being reminded by whisper."],
			type = 'toggle',
			get = function() return self.db.profile.nagging end,
			set = function(v) self.db.profile.nagging = v end,
		},
		reqTimeout = {
			order = 30,
			name = L["Request Timeout"],
			desc = L["The timeout of requests sent out (seconds to wait for answers)."],
			min = 1,
			max = 20,
			step = 1,
			type = 'range',
			get = function() return self.db.profile.requesttimeout end,
			set = function(v) self.db.profile.requesttimeout = v end,
		},
		spacer1 = {
			order = 40,
			type = 'header',
		},
		buffProfileSel = {
			order = 50,
			name = L["Active Profile:"].." "..L["none"],
			desc = L["Active Profile:"].." "..L["none"],
			type = 'group',
			hidden = true,
			args = {},
		},
		spacer2 = {
			order = 60,
			type = 'header',
		},
		buffProfiles = {
			order = 70,
			name = L["Edit Profiles"],
			desc = L["List of available buff profiles."],
			type = 'group',
			hidden = true,
			args = {},
		},
		buffProfileAdd = {
			order = 80,
			name = L["Add New Buff Profile"],
			desc = L["Add a new buff profile."],
			type = 'text',
			usage = "<ProfileName>",
			set = "AddNewProfile",
			get = function() return "" end,
		},
		buffProfileDel = {
			order = 90,
			name = L["Delete Buff Profile"],
			desc = L["Delete a buff profile."],
			type = 'group',
			hidden = true,
			args = {},
		},
		buffProfileRen = {
			order = 100,
			name = L["Rename Buff Profile"],
			desc = L["Rename a buff profile."],
			type = 'group',
			hidden = true,
			args = {},
		},
	}
}
fmBuffCheck.OnMenuRequest = fmBuffCheck.options

fmBuffCheck.repver = {}
fmBuffCheck.repbuf = {}
fmBuffCheck.recver = 0
fmBuffCheck.recbuf = 0
fmBuffCheck.cntver = 0
fmBuffCheck.cntbuf = 0

function fmBuffCheck:OnInitialize()
	self:SetCommPrefix(self.commPrefix)
	self:RegisterComm(self.commPrefix, self.commDist, "OnCommReceive")
	self:UpdateTooltip()
	self:InsertProfiles()
end

function fmBuffCheck:OnEnable()
	self:RegisterChatCommand('/fmBuffCheck', '/fmbc', {
		type = 'execute',
		func = function()
			self:CmdI2buf()
		end
	})
end

function fmBuffCheck:Send(cmd, res)
	self:SendCommMessage(self.commDist, cmd, res)
	self:OnCommReceive(self.commPrefix, self.player, self.commDist, cmd, res)
end

function fmBuffCheck:OnCommReceive(prefix, sender, distribution, cmd, res)
	
	if     cmd == "Q2VER" then self:CmdQ2ver(sender, cmd, res) -- received query for version info
	elseif cmd == "Q2BUF" then self:CmdQ2buf(sender, cmd, res) -- received query for buff info
	elseif cmd == "R2VER" then self:CmdR2ver(sender, cmd, res) -- received report of version info
	elseif cmd == "R2BUF" then self:CmdR2buf(sender, cmd, res) -- received report of buff info
	else                       self:CmdUnkwn(sender, cmd, res) -- received unknown command
	end
	
end

function fmBuffCheck:CmdI2ver()
	-- request an update of all versions from group members
	if(self:IsAuthorized()) then
		self:DebugPrint(L["Requesting version status of all party members..."])
		self:LogFrameClear()
		self.repver = {}
		self.cntver = 0
		self.recver = 0
		self:LogFrameShow()
		self:LogFrameAdd((L["Version request in progress, %s seconds remaining, got %s of %s."]):format(self.db.profile.requesttimeout, self.recver, self:GroupSize()))
		self:Send("Q2VER", false)
		self:ScheduleEvent("fmBuffCheck-DisplayVersion", self.DisplayVersions, 1)
	end
end

function fmBuffCheck:CmdI2buf()
	-- request an update of all buffs from group members
	if(self:IsAuthorized()) then
		self:DebugPrint(L["Requesting buff status of all party members..."])
		self:LogFrameClear()
		self.repbuf = {}
		self.cntbuf = 0
		self.recbuf = 0
		self:LogFrameShow()
		self:LogFrameAdd((L["Buff request in progress, %s seconds remaining, got %s of %s."]):format(self.db.profile.requesttimeout, self.recbuf, self:GroupSize()))
		self:Send("Q2BUF", false)
		self:ScheduleEvent("fmBuffCheck-DisplayBuff", self.DisplayBuffs, 1)
	end
end

function fmBuffCheck:CmdQ2ver(sender, cmd, res)
	 -- received query for version info
	self:DebugPrint((L["Version list request received from %s."]):format(sender))
	self:Send("R2VER", ("%s (%s)"):format(self.version, self.date))
end

function fmBuffCheck:CmdQ2buf(sender, cmd, res)
	-- received query for buff info
	self:DebugPrint((L["Buff list request received from %s."]):format(sender))
	self:GetAndSendBuffs()
end

function fmBuffCheck:CmdR2ver(sender, cmd, res)
	-- received report of version info
	self:DebugPrint((L["Version list result received from %s."]):format(sender))
	self.repver[sender] = res
	self.recver = self.recver + 1
end

function fmBuffCheck:CmdR2buf(sender, cmd, res)
	-- received report of buff info
	self:DebugPrint((L["Buff list result received from %s."]):format(sender))
	self.repbuf[sender] = res
	self.recbuf = self.recbuf + 1
end

function fmBuffCheck:CmdUnkwn(sender, cmd, res)
	-- received unknown command
	self:DebugPrint((L["Unknown QUERY request received from %s: %s."]):format(sender, cmd))
end

function fmBuffCheck:GetAndSendBuffs()
	local num, k, v
	local buffs = {}

	self:DebugPrint("Starting local Buff processing...")
	
	for num = 1, 40 do
		local id = GetPlayerBuff(num, "HELPFUL")
		if id > 0 then
			local name = GetPlayerBuffName(id)
			local time = GetPlayerBuffTimeLeft(id)
			local appl = GetPlayerBuffApplications(id)
			local ttip = self:GetBuffTooltipById(id)
			name = self:ReverseTranslateSafe(name) -- always try to get it in English!
			
			buffs[#buffs + 1] = {
				["type"] = "buf",
				["name"] = name,
				["time"] = time,
				["appl"] = appl,
				["ttip"] = ttip
			}
		end
	end
	
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo(); 
	if hasMainHandEnchant then
		buffs[#buffs + 1] = {
			["type"] = "mhw",
			["name"] = self:WeaponParse("MainHandSlot"),
			["time"] = mainHandExpiration / 1000,
			["appl"] = mainHandCharges,
			["ttip"] = self:GetItemTooltip("MainHandSlot")
		}
	end
	if hasOffHandEnchant then
		buffs[#buffs + 1] = {
			["type"] = "ohw",
			["name"] = self:WeaponParse("SecondaryHandSlot"),
			["time"] = offHandExpiration / 1000,
			["appl"] = offHandCharges,
			["ttip"] = self:GetItemTooltip("SecondaryHandSlot")
		}
	end
	
	if self.db.profile.debugging then 
		for k,v in pairs(buffs) do
			self:LogFrameAdd(("%s: %s (%s)\n%s\n---------"):format(v["type"], v["name"], v["time"], v["ttip"]))
		end
	end
	
	self:Send("R2BUF", buffs)
end

function fmBuffCheck:GetBuffTooltipById(id)
	local i
	local ret = ""
	
	fmBuffCheckTooltip:ClearLines()
	fmBuffCheckTooltip:SetPlayerBuff(id)
	
	for i = 1, fmBuffCheckTooltip:NumLines() do
		local txt = getglobal("fmBuffCheckTooltipTextLeft" .. i):GetText()
		ret = ret .. txt .. "\n"
	end
	return ret
end

function fmBuffCheck:GetItemTooltip(slot)
	fmBuffCheckTooltip:ClearLines()
	local slotId, _ = GetInventorySlotInfo(slot)
	fmBuffCheckTooltip:SetInventoryItem(self.player, slotId)
	local ret = ""
	
	for i = 1, fmBuffCheckTooltip:NumLines() do
		local txt = getglobal("fmBuffCheckTooltipTextLeft" .. i):GetText()
		ret = ret .. txt .. "\n"
    end
    return ret
end

function fmBuffCheck:StringContains(haystack, needle)
	return (string.find(haystack, needle, 1, true) or string.find(haystack, self:TranslateSafe(needle), 1, true))
end

function fmBuffCheck:BuffParse(ttip)
	local txt = ""
	if string.find(ttip, L["Battle Elixir"]  , 1, true) then txt = txt .. "b" end
	if string.find(ttip, L["Guardian Elixir"], 1, true) then txt = txt .. "g" end
	if string.find(ttip, L["Well Fed"]       , 1, true) then txt = "f"	end
    return txt
end

function fmBuffCheck:WeaponParse(slot)
	fmBuffCheckTooltip:ClearLines()
	local slotId, _ = GetInventorySlotInfo(slot)
	fmBuffCheckTooltip:SetInventoryItem(self.player, slotId)
	return getglobal("fmBuffCheckTooltipTextLeft1"):GetText()
end

function fmBuffCheck:FormatTime(time)
	if time > 60 then
		return math.floor(time / 60) .. ":" .. ("%02d"):format(math.floor(time) % 60) .. "m"
	end
	return math.floor(time) .. "s"
end

function fmBuffCheck:PP(obj, style)
	local name = obj["name"]
	local timeleft = obj["time"]

	if (style == 1) then
		if (name == nil or name == "") then
			return string.format("|cffff0000%s|r", L["none"]) 
		end
	
		return string.format("|cff00ff00%s (%s)|r", name, self:FormatTime(timeleft)) 
	else
		if (name == nil or name == "") then
			return string.format("|cffff0000%s|r", L["none"]) 
		end
	
		return string.format("|cff00ff00(%s)|r", self:FormatTime(timeleft)) 
	end
end

function fmBuffCheck:Alert(s, b, g, f, w)
	if self.db.profile.nagging then
	
		local b_, g_, f_, w_, s_
	
		b_ = (b["name"] == nil or b["name"] == "")
		g_ = (g["name"] == nil or g["name"] == "")
		f_ = (f["name"] == nil or f["name"] == "")
		w_ = (w["name"] == nil or w["name"] == "")
		s_ = ""
	
		if (b_ or g_ or f_ or w_) then
			if b_ then
				s_ = s_ .. L["[offensive elixir]"]
			end
			if g_ then
				s_ = s_ .. L["[defensive elixir]"]
			end
			if f_ then
				s_ = s_ .. L["[food buff]"]
			end
			if w_ then
				s_ = s_ .. L["[weapon buff]"]
			end
			SendChatMessage(L["You are missing the following buffs: "] .. s_, "WHISPER", nil, s)
		end
	end
end

function fmBuffCheck:DebugPrint(msg)
	if self.db.profile.debugging then
		self.Print(msg)
	end
end

function fmBuffCheck:OnTooltipUpdate()
	GameTooltip:AddLine("fmBuffCheck")
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine(L["Nagging:"], (self.db.profile.nagging and YES or NO), 1, 1, 0, 1, 1, 1)
	GameTooltip:AddDoubleLine(L["Debugging:"], (self.db.profile.debugging and YES or NO), 1, 1, 0, 1, 1, 1)
	GameTooltip:AddDoubleLine(L["Active Profile:"], self:GetActiveProfile(), 1, 1, 0, 1, 1, 1)
	GameTooltip:AddDoubleLine(L["Request Timeout:"], self.db.profile.requesttimeout .. "s", 1, 1, 0, 1, 1, 1)
	
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("|cffffff00" .. L["Click|r to initiate buff check."], 0.2, 1, 0.2)
	GameTooltip:AddLine("|cffffff00" .. L["Shift-Click|r to initiate version check."], 0.2, 1, 0.2)
end

function fmBuffCheck:OnClick()
	local shift, alt, ctrl = IsShiftKeyDown(), IsAltKeyDown(), IsControlKeyDown()
	if not shift and not alt and not ctrl then
		self:CmdI2buf()
	end
	if shift and not alt and not ctrl then
		self:CmdI2ver()
	end
end

function fmBuffCheck:IsGrouped()
	local inRaid = (GetNumRaidMembers() > 0)
	local inGroup = (GetNumPartyMembers() > 0)
	return (inRaid or inGroup)
end

function fmBuffCheck:GroupSize()
	if (GetNumRaidMembers() > 0) then
		return GetNumRaidMembers()
	end
	if (GetNumPartyMembers() > 0) then
		return GetNumPartyMembers() + 1
	end
	return 1
end

function fmBuffCheck:IsAuthorized()
	return (not self:IsGrouped() or IsPartyLeader() or IsRaidLeader() or IsRaidOfficer())
end

function fmBuffCheck:AddNewProfile(value)
	local cnt = self.db.profile.buffprofilecount
	
	if (cnt == nil or cnt == 0) then
		self.db.profile.buffprofile = {}
		cnt = 0
	end
	
	cnt = cnt + 1
	
	self.db.profile.buffprofilecount = cnt
	self.db.profile.buffprofile[cnt] = {}
	self.db.profile.buffprofile[cnt].name = value
	self:InsertProfiles()
end

function fmBuffCheck:ProfileRen(i, value)
	self.db.profile.buffprofile[i].name = value
	self:InsertProfiles()
end

function fmBuffCheck:SelProfile(value)
	self.db.profile.activeprofile = value
	self:InsertProfiles()
end

function fmBuffCheck:DelProfile(value)
	local cnt = self.db.profile.buffprofilecount
	
	if (cnt == nil or cnt == 0 or value > cnt) then
		self:InsertProfiles()
		return
	end
	
	if (value < cnt) then
		-- move profiles down (boring)
		for i = value+1, cnt do
			self.db.profile.buffprofile[i-1] = self.db.profile.buffprofile[i]
		end
	end
	self.db.profile.buffprofilecount = cnt - 1
	self:InsertProfiles()
end

function fmBuffCheck:InsertProfiles()
	-- clear lists
	self.options.args.buffProfiles.args = {}
	self.options.args.buffProfileDel.args = {}
	self.options.args.buffProfileRen.args = {}
	self.options.args.buffProfileSel.args = {}
	-- hide lists
	self.options.args.buffProfiles.hidden = true
	self.options.args.buffProfileDel.hidden = true
	self.options.args.buffProfileRen.hidden = true
	self.options.args.buffProfileSel.hidden = true
	-- update stuff
	self.options.args.buffProfileSel.name = L["Active Profile:"] .. " " .. self:GetActiveProfile()
	self.options.args.buffProfileSel.desc = L["Active Profile:"] .. " " .. self:GetActiveProfile()
		
	if (self.db.profile.buffprofilecount) then
		local i		
		for i = 1, self.db.profile.buffprofilecount do
			self.options.args.buffProfiles.args[i] = {
				name = self.db.profile.buffprofile[i].name,
				desc = self.db.profile.buffprofile[i].name,
				type = 'group',
				args = self:GetBaseBuffs(i),
			}
			self.options.args.buffProfileDel.args[i] = {
				name = self.db.profile.buffprofile[i].name,
				desc = self.db.profile.buffprofile[i].name,
				type = 'execute',
				func = 'DelProfile',
				passValue = i,
			}
			self.options.args.buffProfileRen.args[i] = {
				name = self.db.profile.buffprofile[i].name,
				desc = self.db.profile.buffprofile[i].name,
				type = 'text',
				usage = "<ProfileName>",
				set = "ProfileRen",
				get = function() return self.db.profile.buffprofile[i].name end,
				passValue = i,
			}		
			self.options.args.buffProfileSel.args[i] = {
				name = self.db.profile.buffprofile[i].name,
				desc = self.db.profile.buffprofile[i].name,
				type = 'execute',
				func = "SelProfile",
				passValue = i,
			}
		end
		self.options.args.buffProfiles.hidden = false
		self.options.args.buffProfileDel.hidden = false
		self.options.args.buffProfileRen.hidden = false
		self.options.args.buffProfileSel.hidden = false
		
	end
end

function fmBuffCheck:GetBaseBuffs(i)
	local t = {}
	local k1, v1
	
	for k1,v1 in pairs(self.basebuffs) do
		t[k1..i] = {
			name = self:TranslateSafe(k1),
			desc = self:TranslateSafe(k1),
			type = 'toggle',
			get = function() return self.db.profile.buffprofile[i][k1] end,
			set = function(v) self.db.profile.buffprofile[i][k1] = v end,
		}
	end
	return t
end

function fmBuffCheck:GetActiveProfile()
	local cnt = self.db.profile.buffprofilecount
	local act = self.db.profile.activeprofile
		
	if (cnt == nil or cnt == 0) then
		self.db.profile.activeprofile = nil
		return ""
	end
	
	if (act == nil or act == 0) then
		self.db.profile.activeprofile = nil
		return ""	
	end
	
	if (act > cnt) then
		self.db.profile.activeprofile = nil
		return ""
	end
	
	return self.db.profile.buffprofile[act].name
end

function fmBuffCheck:ReverseTranslateSafe(txt)
	return B:HasReverseTranslation(txt) and B:GetReverseTranslation(txt) or L:HasReverseTranslation(txt) and L:GetReverseTranslation(txt) or txt
end

function fmBuffCheck:TranslateSafe(txt)
	return B:HasTranslation(txt) and B:GetTranslation(txt) or L:HasTranslation(txt) and L:GetTranslation(txt) or txt
end

function fmBuffCheck:DisplayBuffs()
	local i, k, v, name, grpsiz
	local fmBuffCheck, self = fmBuffCheck, fmBuffCheck
	
	self.cntbuf = self.cntbuf + 1
	grpsiz = self:GroupSize()
	
	-- still counting down?
	if (self.cntbuf < self.db.profile.requesttimeout and self.recbuf < grpsiz) then
		self:LogFrameClear()
		self:LogFrameAdd((L["Buff request in progress, %s seconds remaining, got %s of %s."]):format(self.db.profile.requesttimeout - self.cntver, self.recbuf, grpsiz))
		self:ScheduleEvent("fmBuffCheck-DisplayBuff", self.DisplayBuffs, 1)

	-- or ready to display (after timeout)?
	else
		self:LogFrameClear()
		self:LogFrameAdd((L["Buff request completed, got %s of %s answers:"]):format(self.recbuf, grpsiz))
		-- are we a raid?
		if (GetNumRaidMembers() > 0) then
			-- go through each raid member and display the results
			for i = 1, GetNumRaidMembers() do
				name, _, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i);
				self:ProcessBuff(name)
			end 
		-- are we a group?
		elseif (GetNumPartyMembers() > 0) then
			self:ProcessBuff(self.player)
			for i = 1, GetNumPartyMembers() do
				name, _ = UnitName("party" .. i)
				self:ProcessBuff(name)
			end
		-- are we alone?
		else
			-- just display the results (should be only us)
			self:ProcessBuff(self.player)
		end
	end
end

function fmBuffCheck:ProcessBuff(sender)
	local fmBuffCheck, self = fmBuffCheck, fmBuffCheck
	if (not self.repbuf[sender]) then
		self:LogFrameAdd(("|cffff0000%s: %s|r"):format(sender, L["none"]))
	else
		if (self:GetActiveProfile() > "") then
			local requiredbuffs = {}
			local k1, v1, k2, v2, k3, v3
			local res = self.repbuf[sender]
			
			if (type(res) ~= "table") then
				self:DebugPrint(("Received result of type %s (instead of table) with value %s."):format(type(res), res))
			else
				self:LogFrameAdd(("|cff00ff00%s: |r"):format(sender))
				-- go through all buffs in the profile (if there is one that is...)
				for k1,v1 in pairs(self.db.profile.buffprofile[self.db.profile.activeprofile]) do
					if (v1 and not (k1 == "name")) then
						requiredbuffs[#requiredbuffs + 1] = k1
						self:DebugPrint(("  Required buff: %s -> %s"):format(k1, v1 and YES or NO))
					end
				end
				
				-- get the details of all the buff from the profile 
				for k1,v1 in pairs(requiredbuffs) do
					local user = self.basebuffs[v1].user       --caster of the buff
					local sources = self.basebuffs[v1].sources --equal buffs
					
					local found = false
					for k2,v2 in pairs(sources) do -- there might be several equivalent buffs
						for k3,v3 in pairs(res) do -- go through the retreived buffs
							-- normal case (names match)
							if((v3["name"] == k2 or v3["name"] == self:ReverseTranslateSafe(k2)) and not found) then
								found = true
								self:LogFrameAdd(("  |cff00ff00%s -> %s | %s | %s (%s) >> %s|r"):format(k2, v3["name"], v3["type"], self:FormatTime(v3["time"]), user, found and YES or NO ))
							end
							-- special case (flask and elixir match only partial)
							if((k2 == "Flask" or k2 == "Battle Elixir" or k2 == "Guardian Elixir") and self:StringContains(v3["ttip"], k2) and not found) then
								found = true
								self:LogFrameAdd(("  |cff00ff00%s -> %s | %s | %s (%s) >> %s|r"):format(k2, v3["name"], v3["type"], self:FormatTime(v3["time"]), user, found and YES or NO ))
							end
							
							-- special case (weapon buff has no name)
							if(k2 == "Weapon" and v3["type"] == "mhw" and not found) then
								found = true
								self:LogFrameAdd(("  |cff00ff00%s -> %s | %s | %s (%s) >> %s|r"):format(k2, v3["name"], v3["type"], self:FormatTime(v3["time"]), user, found and YES or NO ))
							end
							if (not found and self.db.profile.debugging) then
								self:LogFrameAdd(("  %s -> %s | %s | %s (%s) >> %s"):format(k2, v3["name"], v3["type"], self:FormatTime(v3["time"]), user, found and YES or NO ))
							end
						end	
					end
					if (not found) then
						self:LogFrameAdd(("  |cffff0000%s -> missing (job of %s)|r"):format(v1, user))
					end
				end
			end		
		end
		
		--self:Print(("%s: b:%s | g:%s | f:%s | w:%s"):format(sender, self:PP(b), self:PP(g), self:PP(f), self:PP(w)))
		--self:LogFrameAdd(("%s: b:%s | g:%s | f:%s | w:%s"):format(sender, self:PP(b, self.db.profile.style), self:PP(g, self.db.profile.style), self:PP(f, self.db.profile.style), self:PP(w, self.db.profile.style)))
	end
end

function fmBuffCheck:DisplayVersions()
	local i, k, v, name, grpsiz
	local fmBuffCheck, self = fmBuffCheck, fmBuffCheck
	
	self.cntver = self.cntver + 1
	grpsiz = self:GroupSize()
	
	-- still counting down?
	if (self.cntver < self.db.profile.requesttimeout and self.recver < grpsiz) then
		self:LogFrameClear()
		self:LogFrameAdd((L["Version request in progress, %s seconds remaining, got %s of %s."]):format(self.db.profile.requesttimeout - self.cntver, self.recver, grpsiz))
		self:ScheduleEvent("fmBuffCheck-DisplayVersion", self.DisplayVersions, 1)

	-- or ready to display (after timeout)?
	else
		self:LogFrameClear()
		self:LogFrameAdd((L["Version request completed, got %s of %s answers:"]):format(self.recver, grpsiz))
		-- are we a raid?
		if (GetNumRaidMembers() > 0) then
			-- go through each raid member and display the results
			for i = 1, GetNumRaidMembers() do
				name, _, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i);
				self:ProcessVersion(name)
			end 
		-- are we a group?
		elseif (GetNumPartyMembers() > 0) then
			self:ProcessVersion(self.player)
			for i = 1, GetNumPartyMembers() do
				name, _ = UnitName("party" .. i)
				self:ProcessVersion(name)
			end
		-- are we alone?
		else
			-- just display the results (should be only us)
			self:ProcessVersion(self.player)
		end
	end
end

-- go through each party member and self and display the results !!TODO!!
--for k,v in pairs(self.repver) do
--	self:LogFrameAdd(k .. ": V" .. v)
--end	

function fmBuffCheck:ProcessVersion(sender)
	local fmBuffCheck, self = fmBuffCheck, fmBuffCheck
	if (self.repver[sender]) then
		self:LogFrameAdd(("|cff00ff00%s: %s|r"):format(sender, self.repver[sender]))
	else
		self:LogFrameAdd(("|cffff0000%s: %s|r"):format(sender, L["none"]))
	end
end

